#include "tetris.h"

 



int timer(int * prev){
	/*    time_t nowtime = time(0);
-     if((nowtime - *prev)>=1){
- 
-         *prev = nowtime;
-         return 1;
-     }*/
	return 0;


}

//void gameLoop(){
//}


void printBoard(struct strGameData * game){
	int x_indx, y_indx;
	//clear board
	DrawGrid();
	
	//draw peices. 
	for(y_indx=0; y_indx<GAME_HEIGHT; y_indx++){
		for(x_indx=0; x_indx<GAME_WIDTH; x_indx++){
			DrawBlock(x_indx,y_indx,game->grid[x_indx][y_indx]);
		}
	}
}

void printTetrad(struct strBlock *Tetrad){
	int x_indx;
	int y_indx;

	for(x_indx=0; x_indx<Tetrad->size; x_indx++){
		for(y_indx=0; y_indx<Tetrad->size; y_indx++){
			if(Tetrad->array[x_indx][y_indx]>0){
				DrawBlock(Tetrad->xpos+ x_indx,Tetrad->ypos + y_indx,Tetrad->array[x_indx][y_indx]);
			}		
		}

	}
}

void printGhost(struct strBlock *Tetrad){
	int x_indx;
	int y_indx;

	for(x_indx=0; x_indx<Tetrad->size; x_indx++){
		for(y_indx=0; y_indx<Tetrad->size; y_indx++){
			if(Tetrad->array[x_indx][y_indx]>0){
				DrawBlock(Tetrad->xpos+ x_indx,Tetrad->ghosty + y_indx,LCD_WHITE);
			}		
		}

	}
}
//void printNext(struct strGameData * game){
void printNext(struct strBlock *Tetrad,int gametype, struct strBlock *Tetrad2){

	int x_indx;
	int y_indx;
	
	//Tetrad = &game->nextBlock;	
	
	for(x_indx=0; x_indx<Tetrad->size; x_indx++){
		for(y_indx=0; y_indx<Tetrad->size; y_indx++){
			if(Tetrad->array[x_indx][y_indx]>0){
				if(Tetrad->type == BOMB){
					DrawBlock(11+ x_indx,3 + y_indx,LCD_BLACK);
				}
				else{
				DrawBlock(11+ x_indx,3 + y_indx,Tetrad->array[x_indx][y_indx]);
				}
			}		
		}
	}
	if(gametype == TWIST_TETRAD){
		for(x_indx=0; x_indx<Tetrad->size; x_indx++){
			for(y_indx=0; y_indx<Tetrad2->size; y_indx++){
				if(Tetrad2->array[x_indx][y_indx]>0){
					DrawBlock(18+ x_indx,3 + y_indx,Tetrad2->array[x_indx][y_indx]);
				}		
			}
		}
	}
	
	
}



void clearTetrad(struct strBlock *Tetrad){
	int x_indx;
	int y_indx;

	for(x_indx=0; x_indx<Tetrad->size; x_indx++){
		for(y_indx=0; y_indx<Tetrad->size; y_indx++){
			if(Tetrad->array[x_indx][y_indx]>0){
				DrawBlock(Tetrad->xpos+ x_indx,Tetrad->ypos + y_indx, LCD_BLACK);
			}		
		}
		
	}


}
void clearGhost(struct strBlock *Tetrad){
	int x_indx;
	int y_indx;

	for(x_indx=0; x_indx<Tetrad->size; x_indx++){
		for(y_indx=0; y_indx<Tetrad->size; y_indx++){
			if(Tetrad->array[x_indx][y_indx]>0){
				DrawBlock(Tetrad->xpos+ x_indx,Tetrad->ghosty + y_indx, LCD_BLACK);
			}		
		}
		
	}


}
void setTetrad(struct strBlock *Tetrad, struct strGameData * game){
	//called when moveDown() detects a collision
	int x_indx;
	int y_indx;
	int chkret;
	for(x_indx = 0; x_indx< Tetrad->size; x_indx++){
		for(y_indx=0; y_indx<Tetrad->size; y_indx++){
			if(Tetrad->array[x_indx][y_indx]>0){
				//printf("filled: (%i, %i)\n", Tetrad->xpos + x_indx, Tetrad->ypos + y_indx);
				if(Tetrad->type == BOMB){
					game->grid[Tetrad->xpos + x_indx][Tetrad->ypos + y_indx] = LCD_BOMB;
				}
				else{
					game->grid[Tetrad->xpos + x_indx][Tetrad->ypos + y_indx] = LCD_RED; //Tetrad->array[x_indx][y_indx];
				}
			}
		}
	}
	

	//check for a full row.
	chkret = checkRow(game);
	if((chkret==0)&&(Tetrad->ypos==0)){
		//game over condition.
		//RestartGame(game);
		printGameOver();
		game->mode = GAMEOUTMENU;
	}
	else{

		game->currBlock = game->nextBlock;
		if(game->gametype == TWIST_TETRAD){
			game->nextBlock = game->next2Block;
			genRandTetrad(&game->next2Block, game->gametype);
		}
		else{
			genRandTetrad(&game->nextBlock, game->gametype);
		}
		clearNext(game->gametype);
		printNext(&game->nextBlock,game->gametype, &game->next2Block);
	}

}


int checkRow(struct strGameData *game){
	int x_indx, y_indx,blocks, count;
	u_int fullrows[GAME_HEIGHT];                      //change to u_byte type
	memset(&fullrows,0,sizeof(u_int)*GAME_HEIGHT);
	count = 0;
	for(y_indx= GAME_HEIGHT-1; y_indx>=0; y_indx--){//init at bottom row, move up.
		blocks=0;

		for (x_indx=0; x_indx<GAME_WIDTH; x_indx++){
			if(game->grid[x_indx][y_indx]==0){
				break;
			}
			else{
				blocks++;
			}
		}
		//printf("blocks in line_%i: %i\n",y_indx, blocks);
		if(blocks == GAME_WIDTH){
			fullrows[y_indx]=0x01;
			count++;
		}

	}
	clearRow(fullrows,&count, game);
	increaseLines(count, game); //NEWCODE
	setScore(count, game); //NEWCODE
	DrawInfo(game->info.score,game->info.level,game->info.lines,game->gametype);
	
	return count;
}
void increaseLines(int count, struct strGameData * game){
	game->info.lines += count;	
	if (game->info.lines >= 10){
		game->info.level++;	
		printTetris();
		game->info.counter =0;
		game->info.lines = 0;
	}
}

//NEWCODE
void setScore(int count, struct strGameData * game){
	if(count==0);
	else if(count==1)
	game->info.score += ((game->info.level)+1)*40;
	else if(count==2)
	game->info.score += ((game->info.level)+1)*100;
	else if(count==3)
	game->info.score += ((game->info.level)+1)*300;
	else if(count>=4)
	game->info.score += ((game->info.level)+1)*1200;	

}



void clearRow(u_int fullrows[],int * count, struct strGameData *game){
	int y_indx, x_indx;
	int y_sub;
	int cleartop;
	if(count>0){
		
		for (y_indx = 0; y_indx<GAME_HEIGHT; y_indx++){
			if (fullrows[y_indx] ==0x01){
				//check if bomb
				for(x_indx=0; x_indx<GAME_WIDTH; x_indx++){
					if(game->grid[x_indx][y_indx] == LCD_BOMB){
						
						if(y_indx-1>=0){
							game->grid[x_indx][y_indx-1] = 0;
							if(x_indx-1>=0){
								game->grid[x_indx-1][y_indx-1] = 0;
							}
							if(x_indx+1<GAME_WIDTH){
								game->grid[x_indx+1][y_indx-1] = 0;
							}
						}
						if (y_indx+1<GAME_HEIGHT){
							game->grid[x_indx][y_indx+1] = 0;
							if(x_indx-1>=0){
								game->grid[x_indx-1][y_indx+1] = 0;	
							}
							if(x_indx+1<GAME_WIDTH){
								game->grid[x_indx+1][y_indx+1] = 0;
							}
						}
					}
				}
				
				
				//CLEARS ROWS;
				
				for(y_sub=y_indx-1; y_sub>=0; y_sub--){
					for(x_indx=0; x_indx<GAME_WIDTH; x_indx++){
						game->grid[x_indx][y_sub+1] = game->grid[x_indx][y_sub];
						
					}
				}
				if (y_indx == 0){
					for(x_indx=0; x_indx<GAME_WIDTH; x_indx++){
						game->grid[x_indx][y_indx] = LCD_BLACK;
						
					}
				}
			}
		}
		for(cleartop=0; cleartop<*count; cleartop++){
			for(x_indx=0; x_indx<GAME_WIDTH; x_indx++){
				game->grid[x_indx][cleartop] = LCD_BLACK;
			}
		}
		printBoard(game);
	}

}

void hideTetrisPanel(struct strGameData *game){
	int max, x_indx, y_indx;

	int clear, initx, inity;
	max = 200;
	clear = (game->info.counter * 18)/200 ;

	initx=1;
	inity=25;
	for(x_indx=0; x_indx<clear; x_indx++){
		for(y_indx=0; y_indx<5; y_indx++){
			DrawBlock(inity + y_indx, initx + x_indx, LCD_WHITE);
		}
	}
	if(game->info.counter  == max){
		printGameOver();
		game->mode = GAMEOUTMENU;
	}



}



int  rotTetrad(struct strBlock *Tetrad, struct strGameData * game){
	//(0,0)(0,1)(0,2)(0,3)
	//(1,0)(1,1)(1,2)(1,3)
	//(2,0)(2,1)(2,2)(2,3)
	//(3,0)(3,1)(3,2)(3,3)
	struct strBlock temp;
	int x_indx;
	int y_indx;
	int blkret;
	int size = Tetrad->size;
	//int temp[FOUR_BLOCK][FOUR_BLOCK];
	int tmpsel; 
	if(game->mode == GAMEPLAY){
		memset(&temp, 0, sizeof(struct strBlock));
		//create rotated tetrad.
		
		for(x_indx=0; x_indx<size; x_indx++){
			for(y_indx=0; y_indx<size; y_indx++){
				temp.array[x_indx][y_indx] = Tetrad->array[size-y_indx-1][x_indx];	
				
			}
		}
		
		temp.size = Tetrad->size;
		temp.type = Tetrad->type;
		temp.xpos = Tetrad->xpos;
		temp.ypos = Tetrad->ypos;
		
		
		//check for collision with board. 
		blkret = blockCollide(&temp, game, NOTGHOST);
		
		if(blkret == 0){
			clearTetrad(Tetrad);
			clearGhost(Tetrad);
			
			for(x_indx=0; x_indx<size; x_indx++){
				for(y_indx=0; y_indx<size; y_indx++){
					Tetrad->array[x_indx][y_indx] = temp.array[x_indx][y_indx]; 		
				}
			}
			printTetrad(Tetrad);
			
			moveGhost(game);
		}
		return blkret;
	}
	else{
		//inside a menu, and has been selected. 
		
		tmpsel = game->menuVer[game->mode].sel;
		switch(game->menuVer[game->mode].item[tmpsel]){
		case PlayPause:
			playPause(game); //play pause function will change info panel and continue game. 
			break;
		case Restart:
			RestartGame(game);
			break;
		case Quit:
			//clear grid.
			game->mode = GAMEOUTMENU;
			DrawMenu(&game->menuVer[game->mode]);
			break;
		case Classic:
			//set gametype to 0
			game->gametype = CLASS_TETRAD;
			RestartGame(game);
			//restart game
			
			break;
		case Twisted:
			//set game type to 1
			game->gametype = TWIST_TETRAD;
			RestartGame(game);
			//restart game
			break;
		case Strategic:	
			game->gametype = STRAT_TETRAD;
			RestartGame(game);
			break;
		}
		
		
	}
}

void RestartGame(struct strGameData * curr_game){
	int gameType = curr_game->gametype;
	memset(curr_game, 0, sizeof(struct strGameData));
	curr_game->grid_h = GAME_HEIGHT;
	curr_game->grid_w = GAME_WIDTH;
	curr_game->info.level = 1;
	curr_game->gametype = gameType;
	
	
	
	genRandTetrad(&curr_game->currBlock,curr_game->gametype);
	genRandTetrad(&curr_game->nextBlock, curr_game->gametype);
	if(curr_game->gametype == TWIST_TETRAD){
		genRandTetrad(&curr_game->next2Block, curr_game->gametype);
	}
	
	initMenus(curr_game);
	
	DrawGrid();
	//score level lines.
	DrawInfo(curr_game->info.score, curr_game->info.level,curr_game->info.lines,curr_game->gametype);
	printTetris();
	printNext(&curr_game->nextBlock, curr_game->gametype, &curr_game->next2Block);
	curr_game->mode = GAMEPLAY;
}

void playPause(struct strGameData * curr_game){
	if(curr_game->mode == GAMEPLAY){
		curr_game->mode = GAMEINMENU;
		DrawMenu(&curr_game->menuVer[GAMEINMENU]);
	}
	else if(curr_game->mode == GAMEINMENU){
		curr_game->mode = GAMEPLAY;
		
		DrawInfo(curr_game->info.score, curr_game->info.level,curr_game->info.lines,curr_game->gametype);
		printNext(&curr_game->nextBlock,curr_game->gametype, &curr_game->next2Block);
	}
	else if(curr_game->mode == GAMEOUTMENU){
		DrawMenu(&curr_game->menuVer[GAMEOUTMENU]);
	}
	
}

void moveUp(struct strGameData * curr_game){
	int tmp_sel;
	if(curr_game->mode == GAMEPLAY){
		//RestartGame(curr_game);
		
		while(moveDown(&curr_game->currBlock, curr_game) ==0){};
		
		//drawScreen();
	}
	else{
		int tmp_sel = curr_game->menuVer[curr_game->mode].sel; //currently selected item. 
		if((tmp_sel-1) == -1){
			curr_game->menuVer[curr_game->mode].sel = curr_game->menuVer[curr_game->mode].itemLen-1;
		}
		else{
			curr_game->menuVer[curr_game->mode].sel--;
		}
		DrawMenu(&curr_game->menuVer[curr_game->mode]);
	}

}
int moveDown(struct strBlock *Tetrad, struct strGameData * curr_game){
	
	//disable interrupts
	
	int tmp_sel;
	int blkret;
	blkret=0;
	if(curr_game->mode == GAMEPLAY){
		Tetrad->ypos++;
		blkret = blockCollide(Tetrad, curr_game,NOTGHOST);
		if(blkret==0){
			Tetrad->ypos--;
			clearGhost(&curr_game->currBlock);
			clearTetrad(Tetrad);
			Tetrad->ypos++;
			printTetrad(Tetrad);
			
			moveGhost(curr_game);
		}
		else{
			Tetrad->ypos--;
			setTetrad(Tetrad, curr_game);
		}
	}
	else{
		int tmp_sel = curr_game->menuVer[curr_game->mode].sel; //currently selected item. 
		if((tmp_sel+1) == curr_game->menuVer[curr_game->mode].itemLen){
			curr_game->menuVer[curr_game->mode].sel = 0;
		}
		else{
			curr_game->menuVer[curr_game->mode].sel++;
		}
		DrawMenu(&curr_game->menuVer[curr_game->mode]);
	}
	return blkret;
	//disable interrupts
}
int moveGhost(struct strGameData * curr_game){
	curr_game->currBlock.ghosty = 0;
	while(blockCollide(&curr_game->currBlock, curr_game, GHOST) ==0){
		curr_game->currBlock.ghosty++;
	}
	curr_game->currBlock.ghosty--;//go back 1
	if(curr_game->currBlock.ghosty > curr_game->currBlock.ypos){
	printGhost(&curr_game->currBlock);
	}
}

void moveLeft(struct strBlock *Tetrad, struct strGameData * curr_game){
	if(curr_game->mode == GAMEPLAY){
		Tetrad->xpos--;
		if(blockCollide(Tetrad, curr_game, NOTGHOST)==0){
			Tetrad->xpos++;
			clearGhost(&curr_game->currBlock);
			clearTetrad(Tetrad);
			Tetrad->xpos--;
			printTetrad(Tetrad);
			
			moveGhost(curr_game);
		}
		else{
			//if block collides, restore orig xpos
			Tetrad->xpos++;
		}
	}
	//do nothing
}
void moveRight(struct strBlock *Tetrad, struct strGameData * curr_game){
	if(curr_game->mode == GAMEPLAY){
		Tetrad->xpos++ ;
		if(blockCollide(Tetrad, curr_game, NOTGHOST)==0){
			Tetrad->xpos--;
			clearGhost(&curr_game->currBlock);
			clearTetrad(Tetrad);
			Tetrad->xpos++ ;
			printTetrad(Tetrad);
			
			moveGhost(curr_game);
		}
		else{
			Tetrad->xpos-- ;
		}
	}
	//do nothing
}



int blockCollide(struct strBlock *Tetrad, struct strGameData * curr_game, int isGhost){
	//check if tetrad sent is out of bounds, or intersects with any blocks on the board. 
	int x_indx, y_indx;
	
	//check if left out of bounds
	if(Tetrad->xpos<0){
		//for(x_indx=0; x_indx<Tetrad->size;x_indx++){
		//	for(y_indx=0; y_indx<-Tetrad->ypos; y_indx++){
		
		for(x_indx=0; x_indx< -Tetrad->xpos; x_indx++){
			for(y_indx=0; y_indx<Tetrad->size; y_indx++){
				if(Tetrad->array[x_indx][y_indx]!=0){
					return 1;
				}
			}
		}
	}  
	//check right out of bounds.
	
	if((Tetrad->xpos+Tetrad->size)>=GAME_WIDTH){
	
		for(x_indx=GAME_WIDTH-Tetrad->xpos; x_indx<Tetrad->size; x_indx++){

			for(y_indx=0; y_indx<Tetrad->size; y_indx++){
				if(Tetrad->array[x_indx][y_indx]!=0){
					return 1;
				}
			}
		}
	}
	//check down out of bounds.
	if(isGhost == NOTGHOST){
		if(Tetrad->ypos+Tetrad->size>=GAME_HEIGHT){
			for(y_indx=GAME_HEIGHT-Tetrad->ypos; y_indx<Tetrad->size; y_indx++){

				for(x_indx=0; x_indx<Tetrad->size; x_indx++){
					if(Tetrad->array[x_indx][y_indx]>0){
						return 1;
					}
				}
			}
		}
	}
	else{
		if(Tetrad->ghosty+Tetrad->size>=GAME_HEIGHT){
			for(y_indx=GAME_HEIGHT-Tetrad->ghosty; y_indx<Tetrad->size; y_indx++){

				for(x_indx=0; x_indx<Tetrad->size; x_indx++){
					if(Tetrad->array[x_indx][y_indx]>0){
						return 1;
					}
				}
			}
		}
	}

	//check if any of blocks intersect with blocks on board already.
	if(isGhost == NOTGHOST){
		for(x_indx=0; x_indx< Tetrad->size; x_indx++){
			for(y_indx=0; y_indx<Tetrad->size; y_indx++){
				if(Tetrad->array[x_indx][y_indx]!=0){
					if(curr_game->grid[Tetrad->xpos+x_indx][Tetrad->ypos+y_indx]!=0){
						//printf("Tetrad value at (%i, %i) %i\n",x_indx, y_indx, Tetrad->array[x_indx][y_indx]);
						// printf("grid non zero at: (%i,%i), val %i\n", Tetrad->xpos+x_indx,Tetrad->ypos+y_indx,curr_game->grid[Tetrad->xpos+x_indx][Tetrad->ypos+y_indx]);
						
						return 1;
					}
				}
			}
		}
	}
	else
	{
		for(x_indx=0; x_indx< Tetrad->size; x_indx++){
			for(y_indx=0; y_indx<Tetrad->size; y_indx++){
				if(curr_game->grid[Tetrad->xpos+x_indx][Tetrad->ghosty+y_indx]!=0){
					//printf("Tetrad value at (%i, %i) %i\n",x_indx, y_indx, Tetrad->array[x_indx][y_indx]);
					// printf("grid non zero at: (%i,%i), val %i\n", Tetrad->xpos+x_indx,Tetrad->ypos+y_indx,curr_game->grid[Tetrad->xpos+x_indx][Tetrad->ypos+y_indx]);
					if(Tetrad->array[x_indx][y_indx]!=0){
						return 1;
					}
				}
			}
		}
		
	}



	//else return 0
	return 0;
}


void genRandTetrad(struct strBlock *Tetrad, int gameType){
	int size;
	int x;
	switch (gameType){
	case CLASS_TETRAD:
		x = rand() % (ZBlock+1) + 0;
		break;
	case TWIST_TETRAD:
		x = rand() % (NBlock17 - NBlock1 +1) + NBlock1;
		break;
	case STRAT_TETRAD:
		x = rand() % (ZBlock+2) + 0;
		break;
	}
	

	
	
	//printf("tetrad generated %i", x);
	if((gameType == STRAT_TETRAD)&&(x == 7)){
		x = BOMB;
	}
	
	createTetrad(Tetrad, x);
}

int genRandTwisted(int mode){
	int x;
	if(mode == TWIST_TETRAD){
		x = rand() % (5);
		return x;
	}
	else{
		return 0;
	}
}
void createTetrad(struct strBlock *Tetrad, int BlockType){
	memset(Tetrad, 0, sizeof(struct strBlock));


	if(BlockType == IBlock){
		//0000
		//1111
		//0000
		//0000
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [0][1] = LCD_CYAN;
		Tetrad->array [1][1] = LCD_CYAN;
		Tetrad->array [2][1] = LCD_CYAN;
		Tetrad->array [3][1] = LCD_CYAN;
		Tetrad->type = IBlock;
		Tetrad->xpos = 2;
	}

	else if(BlockType == JBlock){
		//100
		//111
		//000
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [0][0] = LCD_BLUE;
		Tetrad->array [0][1] = LCD_BLUE;
		Tetrad->array [1][1] = LCD_BLUE;
		Tetrad->array [2][1] = LCD_BLUE;
		Tetrad->type = JBlock;
		Tetrad->xpos = 2;
	}

	else if(BlockType == LBlock){
		//001
		//111
		//000
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [2][0]= LCD_ORANGE;
		Tetrad->array [0][1]= LCD_ORANGE;
		Tetrad->array [1][1]= LCD_ORANGE;
		Tetrad->array [2][1]= LCD_ORANGE;
		Tetrad->type = LBlock;
		Tetrad->xpos = 2;
	}

	else if(BlockType == OBlock){
		//0000
		//0110
		//0110
		//0000
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][1] = LCD_YELLOW;
		Tetrad->array [1][2] = LCD_YELLOW;
		Tetrad->array [2][1] = LCD_YELLOW;
		Tetrad->array [2][2] = LCD_YELLOW;
		Tetrad->type = OBlock;
		Tetrad->xpos = 2;
	}

	else if(BlockType == SBlock){
		//011
		//110
		//000
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_GREEN;
		Tetrad->array [2][0] = LCD_GREEN;
		Tetrad->array [0][1] = LCD_GREEN;
		Tetrad->array [1][1] = LCD_GREEN;
		Tetrad->type = SBlock;
		Tetrad->xpos = 2;
	}

	else if(BlockType == TBlock){
		//010
		//111
		//000	
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] =  LCD_PURPLE;
		Tetrad->array [0][1] =  LCD_PURPLE;
		Tetrad->array [1][1] =  LCD_PURPLE;
		Tetrad->array [2][1] =  LCD_PURPLE;
		Tetrad->type = TBlock;
		Tetrad->xpos = 2;
	}

	else if(BlockType == ZBlock){
		//110
		//011
		//000
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [0][0] = LCD_RED;
		Tetrad->array [1][0] = LCD_RED;
		Tetrad->array [1][1] = LCD_RED;
		Tetrad->array [2][1] = LCD_RED;
		Tetrad->type = ZBlock;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock1){
		//101
		//111
		//000
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [0][0] = LCD_RED;
		Tetrad->array [0][1] = LCD_RED;
		Tetrad->array [1][1] = LCD_RED;
		Tetrad->array [2][0] = LCD_RED;
		Tetrad->array [2][1] = LCD_RED;
		Tetrad->type = NBlock1;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock2){
		//010
		//111
		//010
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_PURPLE;
		Tetrad->array [0][1] = LCD_PURPLE;
		Tetrad->array [1][1] = LCD_PURPLE;
		Tetrad->array [2][1] = LCD_PURPLE;
		Tetrad->array [1][2] = LCD_PURPLE;
		Tetrad->type = NBlock2;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock3){
		//001
		//011
		//110
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [2][0] = LCD_GREEN;
		Tetrad->array [1][1] = LCD_GREEN;
		Tetrad->array [2][1] = LCD_GREEN;
		Tetrad->array [0][2] = LCD_GREEN;
		Tetrad->array [1][2] = LCD_GREEN;
		Tetrad->type = NBlock3;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock4){
		//001
		//001
		//111
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [2][0] = LCD_YELLOW;
		Tetrad->array [2][1] = LCD_YELLOW;
		Tetrad->array [2][2] = LCD_YELLOW;
		Tetrad->array [0][2] = LCD_YELLOW;
		Tetrad->array [1][2] = LCD_YELLOW;
		Tetrad->type = NBlock4;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock5){
		//111
		//010
		//010
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [0][0] = LCD_ORANGE;
		Tetrad->array [1][0] = LCD_ORANGE;
		Tetrad->array [2][0] = LCD_ORANGE;
		Tetrad->array [1][1] = LCD_ORANGE;
		Tetrad->array [1][2] = LCD_ORANGE;
		Tetrad->type = NBlock5;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock6){
		//011
		//110
		//010
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_BLUE;
		Tetrad->array [2][0] = LCD_BLUE;
		Tetrad->array [1][1] = LCD_BLUE;
		Tetrad->array [0][1] = LCD_BLUE;
		Tetrad->array [1][2] = LCD_BLUE;
		Tetrad->type = NBlock6;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock7){
		//110
		//011
		//010
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [0][0] = LCD_CYAN;
		Tetrad->array [1][0] = LCD_CYAN;
		Tetrad->array [1][1] = LCD_CYAN;
		Tetrad->array [2][1] = LCD_CYAN;
		Tetrad->array [1][2] = LCD_CYAN;
		Tetrad->type = NBlock7;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock8){
		//0100
		//0100
		//0100
		//1100
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][0] = LCD_CYAN;
		Tetrad->array [1][1] = LCD_CYAN;
		Tetrad->array [1][2] = LCD_CYAN;
		Tetrad->array [1][3] = LCD_CYAN;
		Tetrad->array [0][3] = LCD_CYAN;
		Tetrad->type = NBlock8;
		Tetrad->xpos = 2;
	}
	else if(BlockType == NBlock9){
		//0100
		//0100
		//0100
		//0110
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][0] = LCD_BLUE;
		Tetrad->array [1][1] = LCD_BLUE;
		Tetrad->array [1][2] = LCD_BLUE;
		Tetrad->array [1][3] = LCD_BLUE;
		Tetrad->array [2][3] = LCD_BLUE;
		Tetrad->type = NBlock9;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock10){
		//0100
		//0110
		//0100
		//0100
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][0] = LCD_ORANGE;
		Tetrad->array [1][1] = LCD_ORANGE;
		Tetrad->array [1][2] = LCD_ORANGE;
		Tetrad->array [1][3] = LCD_ORANGE;
		Tetrad->array [2][1] = LCD_ORANGE;
		Tetrad->type = NBlock10;
		Tetrad->xpos = 2;
	}
	

		

	
	else if(BlockType == NBlock11){
		//011
		//011
		//010
		
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_YELLOW;
		Tetrad->array [1][1] = LCD_YELLOW;
		Tetrad->array [1][2] = LCD_YELLOW;
		Tetrad->array [2][0] = LCD_YELLOW;
		Tetrad->array [2][1] = LCD_YELLOW;
		Tetrad->type = NBlock11;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock12){
		//110
		//110
		//010
		
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_GREEN;
		Tetrad->array [1][1] = LCD_GREEN;
		Tetrad->array [1][2] = LCD_GREEN;
		Tetrad->array [0][0] = LCD_GREEN;
		Tetrad->array [0][1] = LCD_GREEN;
		Tetrad->type = NBlock12;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock13){
		//0100
		//0100
		//1100
		//1000
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][0] = LCD_PURPLE;
		Tetrad->array [1][1] = LCD_PURPLE;
		Tetrad->array [1][2] = LCD_PURPLE;
		Tetrad->array [0][2] = LCD_PURPLE;
		Tetrad->array [0][3] = LCD_PURPLE;
		Tetrad->type = NBlock13;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock14){
		//0100
		//0100
		//0110
		//0010
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][0] = LCD_RED;
		Tetrad->array [1][1] = LCD_RED;
		Tetrad->array [1][2] = LCD_RED;
		Tetrad->array [2][2] = LCD_RED;
		Tetrad->array [2][3] = LCD_RED;
		Tetrad->type = NBlock14;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock15){
		//0100
		//1100
		//0100
		//0100
		Tetrad->size = FOUR_BLOCK;
		Tetrad->array [1][0] = LCD_GREEN;
		Tetrad->array [1][1] = LCD_GREEN;
		Tetrad->array [1][2] = LCD_GREEN;
		Tetrad->array [1][3] = LCD_GREEN;
		Tetrad->array [0][1] = LCD_GREEN;
		Tetrad->type = NBlock15;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock16){
		//011
		//010
		//110
		
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_ORANGE;
		Tetrad->array [1][1] = LCD_ORANGE;
		Tetrad->array [1][2] = LCD_ORANGE;
		Tetrad->array [2][0] = LCD_ORANGE;
		Tetrad->array [0][2] = LCD_ORANGE;
		Tetrad->type = NBlock16;
		Tetrad->xpos = 2;
	}
	
	else if(BlockType == NBlock17){
		//110
		//010
		//011
		
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][0] = LCD_RED;
		Tetrad->array [1][1] = LCD_RED;
		Tetrad->array [1][2] = LCD_RED;
		Tetrad->array [0][0] = LCD_RED;
		Tetrad->array [2][2] = LCD_RED;
		Tetrad->type = NBlock17;
		Tetrad->xpos = 2;
	}
	
	else if (BlockType == BOMB){
		Tetrad->size = THREE_BLOCK;
		Tetrad->array [1][1] = LCD_WHITE;
		Tetrad->type = BOMB;
		Tetrad->xpos = 2;
	}
	else{
		Tetrad->type = ERR;
		Tetrad->size = ERR;
	}

}



void initMenus(struct strGameData * curr_game){


	curr_game->menuVer[0].item[0] = PlayPause;
	curr_game->menuVer[0].item[1] = Restart;
	curr_game->menuVer[0].item[2] = Quit;
	curr_game->menuVer[0].itemLen = 3;
	curr_game->menuVer[0].sel = 0;

	curr_game->menuVer[1].item[0] = Classic;
	curr_game->menuVer[1].item[1] = Twisted;
	curr_game->menuVer[1].item[2] = Strategic;
	curr_game->menuVer[1].itemLen =3;
	curr_game->menuVer[1].sel = 0;
}


void printTetris(){
	int x_indx, y_indx;
	int initx, inity;
	int tetarr [18][5] = 
	{{0,0,0,0, LCD_RED},
		{LCD_RED,LCD_RED,LCD_RED,LCD_RED,LCD_RED},
		{0,0,0,0, LCD_RED},
		{LCD_GREEN,LCD_GREEN,LCD_GREEN,LCD_GREEN,LCD_GREEN},
		{LCD_GREEN,0,LCD_GREEN,0,LCD_GREEN},
		{LCD_GREEN,0,0,0,LCD_GREEN},
		{0,0,0,0, LCD_ORANGE},
		{LCD_ORANGE,LCD_ORANGE,LCD_ORANGE,LCD_ORANGE,LCD_ORANGE},
		{0,0,0,0, LCD_ORANGE},
		{LCD_PURPLE,LCD_PURPLE,LCD_PURPLE,LCD_PURPLE,LCD_PURPLE},
		{0,0,LCD_PURPLE,0,LCD_PURPLE},
		{LCD_PURPLE,LCD_PURPLE,0,LCD_PURPLE,LCD_PURPLE},
		{LCD_BLUE,0,0,0,LCD_BLUE},
		{LCD_BLUE,LCD_BLUE,LCD_BLUE,LCD_BLUE,LCD_BLUE},
		{LCD_BLUE,0,0,0,LCD_BLUE},
		{LCD_RED,0,LCD_RED,LCD_RED,LCD_RED},
		{LCD_RED,0,LCD_RED,0,LCD_RED},
		{LCD_RED,LCD_RED,LCD_RED,0,LCD_RED}
	};

	initx=1;
	inity=25;
	for(x_indx=0; x_indx<18; x_indx++){
		for(y_indx=0; y_indx<5; y_indx++){
			DrawBlock(inity + y_indx, initx + x_indx, tetarr[x_indx][y_indx]);
		}
	}



}


void printGameOver(){
	//clear game screen
	DrawGrid();


	//draw game over chars


	//LETER O
	DrawBlock(0,1,LCD_RED);
	DrawBlock(1,1,LCD_RED);
	DrawBlock(2,1,LCD_RED);
	DrawBlock(3,1,LCD_RED);
	DrawBlock(4,1,LCD_RED);
	DrawBlock(0,2,LCD_RED);
	DrawBlock(4,2,LCD_RED);
	DrawBlock(1,3,LCD_RED);
	DrawBlock(2,3,LCD_RED);
	DrawBlock(3,3,LCD_RED);
	DrawBlock(4,3,LCD_RED);

	//LETTER V
	DrawBlock(1,5,LCD_RED);
	DrawBlock(2,5,LCD_RED);
	DrawBlock(3,5,LCD_RED);
	DrawBlock(4,5,LCD_RED);
	DrawBlock(0,6,LCD_RED);
	DrawBlock(1,7,LCD_RED);
	DrawBlock(2,7,LCD_RED);
	DrawBlock(3,7,LCD_RED);
	DrawBlock(4,7,LCD_RED);

	//Letter E

	DrawBlock(0,9,LCD_RED);
	DrawBlock(1,9,LCD_RED);
	DrawBlock(2,9,LCD_RED);
	DrawBlock(3,9,LCD_RED);
	DrawBlock(4,9,LCD_RED);
	DrawBlock(0,10,LCD_RED);
	DrawBlock(2,10,LCD_RED);
	DrawBlock(4,10,LCD_RED);
	DrawBlock(0,11,LCD_RED);
	DrawBlock(4,11,LCD_RED);

	//LETER R
	DrawBlock(0,13,LCD_RED);
	DrawBlock(1,13,LCD_RED);
	DrawBlock(2,13,LCD_RED);
	DrawBlock(3,13,LCD_RED);
	DrawBlock(4,13,LCD_RED);
	DrawBlock(2,14,LCD_RED);
	DrawBlock(4,14,LCD_RED);
	DrawBlock(0,15,LCD_RED);
	DrawBlock(1,15,LCD_RED);
	DrawBlock(3,15,LCD_RED);
	DrawBlock(4,15,LCD_RED);

	//LETER G
	DrawBlock(5,0,LCD_RED);
	DrawBlock(6,0,LCD_RED);
	DrawBlock(7,0,LCD_RED);
	DrawBlock(8,0,LCD_RED);
	DrawBlock(9,0,LCD_RED);
	DrawBlock(5,1,LCD_RED);
	DrawBlock(9,1,LCD_RED);
	DrawBlock(5,2,LCD_RED);
	DrawBlock(6,2,LCD_RED);
	DrawBlock(7,2,LCD_RED);
	DrawBlock(9,2,LCD_RED);

	//LETTER A
	DrawBlock(5,4,LCD_RED);
	DrawBlock(6,4,LCD_RED);
	DrawBlock(7,4,LCD_RED);
	DrawBlock(8,4,LCD_RED);
	DrawBlock(7,5,LCD_RED);
	DrawBlock(9,5,LCD_RED);
	DrawBlock(5,6,LCD_RED);
	DrawBlock(6,6,LCD_RED);
	DrawBlock(7,6,LCD_RED);
	DrawBlock(8,6,LCD_RED);

	//LETTER M
	DrawBlock(5,8,LCD_RED);
	DrawBlock(6,8,LCD_RED);
	DrawBlock(7,8,LCD_RED);
	DrawBlock(8,8,LCD_RED);
	DrawBlock(9,8,LCD_RED);
	DrawBlock(9,9,LCD_RED);
	DrawBlock(6,10,LCD_RED);
	DrawBlock(7,10,LCD_RED);
	DrawBlock(8,10,LCD_RED);
	DrawBlock(9,10,LCD_RED);
	DrawBlock(9,11,LCD_RED);
	DrawBlock(5,12,LCD_RED);
	DrawBlock(6,12,LCD_RED);
	DrawBlock(7,12,LCD_RED);
	DrawBlock(8,12,LCD_RED);
	DrawBlock(9,12,LCD_RED);

	//LETTER E
	DrawBlock(5,14,LCD_RED);
	DrawBlock(6,14,LCD_RED);
	DrawBlock(7,14,LCD_RED);
	DrawBlock(8,14,LCD_RED);
	DrawBlock(9,14,LCD_RED);
	DrawBlock(5,15,LCD_RED);
	DrawBlock(7,15,LCD_RED);
	DrawBlock(9,15,LCD_RED);
	DrawBlock(5,16,LCD_RED);
	DrawBlock(9,16,LCD_RED);
}
